using System;
using System.Collections.ObjectModel;
using System.ComponentModel;
public class ViewModel
    {
     public ObservableCollection<TreeData> TreeSource1 { get; set; }
     public ObservableCollection<TreeData> TreeSource2 { get; set; }

     private int NoLevels = 3;

        public ViewModel()
        {
            CreateData();
            
        }

        private string[] names = { "John", "Kim", "Sandy", "Mark", "Josh", "Jim", "Sam", "Mary", 
                                     "Harry", "Sue", "Chris", "Joe", "Carl" };
        private string[] recDescs = { "Test", "Duplicate", "Standard", "Trial", "Expired", "New", "History" };
        private void CreateData()
        {
            Random r = new Random();
            TreeSource1 = new ObservableCollection<TreeData>();
            for (int i = 0; i < 100; i++)
            {
                TreeData td = new TreeData()
                {
                    ID = i,
                    Name = names[r.Next(13)],
                    RecDesc = recDescs[r.Next(7)],
                    RecDate = DateTime.Today.AddDays(r.Next(10)),
                    Children = new ObservableCollection<TreeData>()
                };
                AddChildren(td, 1);
                TreeSource1.Add(td);
            }
            TreeSource2 = new ObservableCollection<TreeData>();
            for (int i = 0; i < 100; i++)
            {
                TreeData td = new TreeData()
                {
                    ID = i,
                    Name = names[r.Next(13)],
                    RecDesc = recDescs[r.Next(7)],
                    RecDate = DateTime.Today.AddDays(r.Next(10)),
                    Children = new ObservableCollection<TreeData>()
                };
                AddChildren(td, 1);
                TreeSource2.Add(td);
            }

         
        }
        private void AddChildren(TreeData gd, int levelNo)
        {
            Random r = new Random();
            int NoChildren = r.Next(2,10);
            string levelStr = "1";
            for (int i = 0; i < levelNo; i++)
                levelStr += "0";


            int levelMult = int.Parse(levelStr);
            for (int i = 0; i < NoChildren; i++)
            {
                TreeData gd2 = new TreeData()
                {
                    ID = levelMult + i,
                    Name = names[r.Next(13)],
                    RecDesc = recDescs[r.Next(7)],
                    RecDate = DateTime.Today.AddDays(r.Next(10)),
                    Children = new ObservableCollection<TreeData>()
                };

                if (levelNo < NoLevels)
                    AddChildren(gd2, levelNo + 1);

                gd.Children.Add(gd2);
            }
        }

    }
    public class TreeData : INotifyPropertyChanged
    {
        
        private int id;
        private string name;
        private DateTime recDt;
        private string rec_desc;
        public ObservableCollection<TreeData> Children { get; set; }


        public int ID
        {
            get { return id; }
            set
            {
                if (id != value)
                {
                    id = value;
                    OnPropertyChanged("ID");
                }
            }
        }

        public string Name
        {
            get { return name; }
            set
            {
                if (name != value)
                {
                    name = value;
                    OnPropertyChanged("Name");
                }
            }
        }

        public string RecDesc
        {
            get { return rec_desc; }
            set
            {
                if (rec_desc != value)
                {
                    rec_desc = value;
                    OnPropertyChanged("RecDesc");
                }
            }
        }

        public DateTime RecDate
        {
            get { return recDt; }
            set
            {
                if (recDt != value)
                {
                    recDt = value;
                    OnPropertyChanged("RecDate");
                }
            }
        }



        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }